#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "cwp.h"

void difx(float *vin, float *vout, complex* ckx, int nx)
{
  int i;
  float tmp;
  complex *z;
  
  void pfacc (int isign, int n, complex z[]);

  z = (complex*) alloc1(nx,sizeof(complex));

  for (i=0; i<nx; i++) {
    z[i].r = vin[i];
    z[i].i = 0.;
  }
  
  pfacc(-1, nx, z);

  for (i=0; i<nx; i++) {
    tmp = z[i].r*ckx[i].r - z[i].i*ckx[i].i;
    z[i].i = z[i].r*ckx[i].i + z[i].i*ckx[i].r;
    z[i].r = tmp;
  }

  pfacc(1, nx, z);

  for (i=0; i<nx; i++) {
    vout[i] = z[i].r/nx;
  }

}
