subroutine ffork(lx, cx, signi) 
!**************************************************************
      implicit none
      integer , intent(in) :: lx 
      real , intent(in) :: signi 
      complex , intent(inout) :: cx(*) 
!-----------------------------------------------
      integer :: j, i, m, l, istep 
      real :: pi, sc 
      complex :: carg, cw, ctemp 
!-----------------------------------------------
      pi = 3.14159265 
      j  = 1 
      sc = 1./float ( lx )  
      sc = sqrt ( sc )  
      do i = 1, lx 
         if (i <= j) then 
            ctemp = cx(j)*sc 
            cx(j) = cx(i)*sc 
            cx(i) = ctemp 
         endif 
         m = lx/2 
         if (j <= m) go to 100 
         j = j - m 
         m = m/2 
         do while ( m >= 1 ) 
            if (j <= m) go to 100 
            j = j - m 
            m = m/2 
         end do 
  100    continue 
         j = j + m 
      end do 
      l = 1 
  110 continue 
      istep = 2*l 
      do m = 1, l 
         carg = cmplx(0.,1.) * ( pi*signi*float(m - 1) ) /float (l)  
         cw   = cexp ( carg )  
         do i = m, lx, istep 
            ctemp   = cw*cx(i+l) 
            cx(i+l) = cx(i) - ctemp 
            cx(i)   = cx(i) + ctemp 
         end do 
      end do 
      l = istep 
      if (l < lx) go to 110 
      return  
end subroutine ffork 
